## ros-eloquent-rviz-ogre-vendor 7.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rviz_ogre_vendor)

find_package(ament_cmake REQUIRED)

set(PACKAGE_VERSION "1.0.0")

if(WIN32)
  set(BUILDING_FREETYPE_LOCALLY ON)
  set(BUILDING_ZLIB_LOCALLY ON)
else()
  set(BUILDING_FREETYPE_LOCALLY OFF)
  set(BUILDING_ZLIB_LOCALLY OFF)
endif()

if(WIN32 AND NOT ${CMAKE_VERBOSE_MAKEFILE})
  set(should_log ON)  # prevent warnings in Windows CI
else()
  set(should_log OFF)
endif()

macro(build_freetype)
  set(extra_cmake_args)
  set(FREETYPE_CXX_FLAGS ${CMAKE_CXX_FLAGS})

  if(WIN32)
    list(APPEND FREETYPE_CXX_FLAGS "/w")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w")
  endif()

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
  else()
    list(APPEND extra_cmake_args "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
    list(APPEND extra_cmake_args "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
  endif()
  list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=${FREETYPE_CXX_FLAGS}")

  include(ExternalProject)
  ExternalProject_Add(freetype-2.8.1
    URL https://git.savannah.gnu.org/cgit/freetype/freetype2.git/snapshot/freetype2-VER-2-6-5.tar.gz
    URL_MD5 0dd62a0125895431e074a3df29f94d69
    TIMEOUT 600
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/freetype_install
      ${extra_cmake_args}
      -Wno-dev
      -DWITH_ZLIB=OFF
      -DWITH_BZip2=OFF
      -DWITH_PNG=OFF
      -DWITH_HarfBuzz=OFF
  )

  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/freetype_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

macro(build_zlib)
  set(extra_cmake_args)
  set(ZLIB_CXX_FLAGS ${CMAKE_CXX_FLAGS})

  if(WIN32)
    list(APPEND ZLIB_CXX_FLAGS "/w")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w")
  endif()

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
  else()
    list(APPEND extra_cmake_args "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
    list(APPEND extra_cmake_args "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
  endif()
  list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=${ZLIB_CXX_FLAGS}")

  include(ExternalProject)
  ExternalProject_Add(zlib-1.2.11
    URL https://www.zlib.net/fossils/zlib-1.2.11.tar.gz
    URL_MD5 1c9f62f0778697a09d36121ead88e08e
    TIMEOUT 600
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/zlib-install
      ${extra_cmake_args}
      -Wno-dev
  )

  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/zlib-install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

macro(build_ogre)
  set(extra_cmake_args)
  set(OGRE_CXX_FLAGS)
  # standard library is important for linking, but the other cxx flags are not
  if(CMAKE_CXX_FLAGS MATCHES "-stdlib=libc\\+\\+")
    set(OGRE_CXX_FLAGS "${OGRE_CXX_FLAGS} -stdlib=libc++")
  endif()

  if(DEFINED CMAKE_BUILD_TYPE)
    list(APPEND extra_cmake_args -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})
  endif()

  if(WIN32)
    set(OGRE_CXX_FLAGS "${OGRE_CXX_FLAGS} /w /EHsc")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=/w /EHsc")
  elseif(APPLE)
    set(OGRE_CXX_FLAGS "${OGRE_CXX_FLAGS} -std=c++14 -stdlib=libc++ -w")
    list(APPEND extra_cmake_args "-DCMAKE_OSX_ARCHITECTURES='x86_64'")
  else()  # Linux
    # include Clang -Wno-everything to disable warnings in that build. GCC doesn't mind it
    set(OGRE_CXX_FLAGS "${OGRE_CXX_FLAGS} -std=c++14 -w -Wno-everything")
    list(APPEND extra_cmake_args "-DCMAKE_C_FLAGS=-w")
  endif()
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_GL:BOOL=TRUE")
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_D3D11:BOOL=OFF")
  list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_D3D9:BOOL=OFF")
  list(APPEND extra_cmake_args "-DCMAKE_CXX_FLAGS=${OGRE_CXX_FLAGS}")

  # Uncomment this line to enable the GL3PLUS render engine
  # list(APPEND extra_cmake_args "-DOGRE_BUILD_RENDERSYSTEM_GL3PLUS:BOOL=TRUE")

  # These next lines can be used to disable some of the components or plugins for OGRE
  list(APPEND extra_cmake_args "-DOGRE_CONFIG_ENABLE_ZIP:BOOL=ON")

  if(BUILDING_FREETYPE_LOCALLY)
    list(APPEND extra_cmake_args
      "-DFREETYPE_HOME=${CMAKE_CURRENT_BINARY_DIR}/freetype_install")
  endif()
  if(BUILDING_ZLIB_LOCALLY)
    list(APPEND extra_cmake_args
      "-DZLIB_ROOT=${CMAKE_CURRENT_BINARY_DIR}/zlib-install")
  endif()

  if(DEFINED CMAKE_TOOLCHAIN_FILE)
    list(APPEND extra_cmake_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
  else()
    list(APPEND extra_cmake_args "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
    list(APPEND extra_cmake_args "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
  endif()

  include(ExternalProject)
  ExternalProject_Add(ogre-v1.12.1
    URL https://github.com/OGRECave/ogre/archive/v1.12.1.zip
    URL_MD5 cdbea4006d223c173e0a93864111b936
    TIMEOUT 1200
    LOG_CONFIGURE ${should_log}
    LOG_BUILD ${should_log}
    CMAKE_ARGS
      -DOGRE_STATIC:BOOL=OFF
      -DOGRE_DEPENDENCIES_DIR=${CMAKE_CURRENT_BINARY_DIR}/ogredeps
      -DOGRE_INSTALL_PDB:BOOL=OFF
      -DOGRE_BUILD_DEPENDENCIES:BOOL=OFF
      -DOGRE_BUILD_TESTS:BOOL=OFF
      -DOGRE_BUILD_SAMPLES:BOOL=FALSE
      -DOGRE_INSTALL_SAMPLES:BOOL=FALSE
      -DOGRE_INSTALL_SAMPLES_SOURCE:BOOL=FALSE
      -DOGRE_CONFIG_THREADS:STRING=0
      -DOGRE_RESOURCEMANAGER_STRICT:STRING=2
      -DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/ogre_install
      -DOGRE_BUILD_LIBS_AS_FRAMEWORKS:BOOL=OFF
      -DOGRE_BUILD_COMPONENT_PYTHON:BOOL=FALSE
      -DOGRE_BUILD_COMPONENT_JAVA:BOOL=FALSE
      -DOGRE_BUILD_COMPONENT_CSHARP:BOOL=FALSE
      -DOGRE_BUILD_COMPONENT_BITES:BOOL=FALSE
      ${extra_cmake_args}
      -Wno-dev
    PATCH_COMMAND
      ${CMAKE_COMMAND} -E chdir <SOURCE_DIR> patch${CMAKE_EXECUTABLE_SUFFIX} -p1 -N < ${CMAKE_CURRENT_SOURCE_DIR}/pragma-patch.diff
    COMMAND
      ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/FindFreetype.cmake ${CMAKE_CURRENT_BINARY_DIR}/ogre-v1.12.1-prefix/src/ogre-v1.12.1/CMake/Packages/FindFreetype.cmake
  )

  if(BUILDING_FREETYPE_LOCALLY)
    add_dependencies(ogre-v1.12.1 freetype-2.8.1)
  endif()
  if(BUILDING_ZLIB_LOCALLY)
    add_dependencies(ogre-v1.12.1 zlib-1.2.11)
  endif()

  # The external project will install to the build folder, but we'll install that on make install.
  install(
    DIRECTORY
      ${CMAKE_CURRENT_BINARY_DIR}/ogre_install/
    DESTINATION
      ${CMAKE_INSTALL_PREFIX}/opt/rviz_ogre_vendor
  )
endmacro()

if(BUILDING_FREETYPE_LOCALLY)
  build_freetype()
endif()
if(BUILDING_ZLIB_LOCALLY)
  build_zlib()
endif()

build_ogre()

if(WIN32)
  ament_environment_hooks(env_hook/rviz_ogre_vendor_library_path.bat)
  set(ENV_VAR_NAME "PATH")
  set(ENV_VAR_VALUE "opt\\rviz_ogre_vendor\\bin")
else()
  ament_environment_hooks(env_hook/rviz_ogre_vendor_library_path.sh)
  if(APPLE)
    set(ENV_VAR_NAME "DYLD_LIBRARY_PATH")
  else()
    set(ENV_VAR_NAME "LD_LIBRARY_PATH")
  endif()
  set(ENV_VAR_VALUE "opt/rviz_ogre_vendor/lib")
endif()
ament_environment_hooks(env_hook/rviz_ogre_vendor_library_path.dsv.in)

ament_package(
  CONFIG_EXTRAS "rviz_ogre_vendor-extras.cmake.in"
)

=== debian/changelog ===
ros-eloquent-rviz-ogre-vendor (7.0.7-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Wed, 02 Dec 2020 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.6-1bionic) bionic; urgency=high

  * Update maintainer list (#618 <https://github.com/ros2/rviz/issues/618>)
  * Contributors: Michael Jeronimo

 -- Jacob Perron <jacob@openrobotics.org>  Tue, 27 Oct 2020 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.5-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 17 Apr 2020 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.4-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 17 Jan 2020 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.3-1bionic) bionic; urgency=high

  * Skip freetype2 dependencies (#405 <https://github.com/ros2/rviz/issues/405>)
  * Contributors: Sean Yen

 -- William Woodall <william@osrfoundation.org>  Wed, 13 Nov 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.2-1bionic) bionic; urgency=high

  * Switch back to patch instead of git apply (#470 <https://github.com/ros2/rviz/issues/470>)
  * Remove OGRE_BUILD_COMPONENT_SAMPLES cmake arg.
  * Contributors: Chris Lalancette

 -- William Woodall <william@osrfoundation.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.1-1bionic) bionic; urgency=high

  * Fix the rviz_ogre_vendor packaging.
  * Contributors: Chris Lalancette

 -- William Woodall <william@osrfoundation.org>  Fri, 04 Oct 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (7.0.0-1bionic) bionic; urgency=high

  * Add .dsv file beside custom environment hook (#449 <https://github.com/ros2/rviz/issues/449>)
  * Upgrade from Ogre 1.10 to Ogre 1.12.1 (#394 <https://github.com/ros2/rviz/issues/394>)
  * Mojave compatibility (#414 <https://github.com/ros2/rviz/issues/414>)
  * Contributors: Dirk Thomas, Karsten Knese, Martin Idel

 -- William Woodall <william@osrfoundation.org>  Fri, 27 Sep 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (6.1.1-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 29 May 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (6.1.0-1bionic) bionic; urgency=high

  * Upgraded to OGRE 1.10.12 to get a macOS fix but also not break any APIs by upgrading to OGRE 1.11.x. (#380 <https://github.com/ros2/rviz/issues/380>)
  * Contributors: Emerson Knapp

 -- William Woodall <william@osrfoundation.org>  Mon, 20 May 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (6.0.0-1bionic) bionic; urgency=high

  * Suppress ogre_vendor warnings in clang+libcxx build. The -w flag was not strong enough for Clang builds. (#389 <https://github.com/ros2/rviz/issues/389>)
    Signed-off-by: Emerson Knapp <mailto:eknapp@amazon.com>
  * Pass through only the stdlib flag to the vendor build, instead of all C++ flags (#388 <https://github.com/ros2/rviz/issues/388>)
    Signed-off-by: Emerson Knapp <mailto:eknapp@amazon.com>
  * Pass through CXX flags to OGRE vendor build (#381 <https://github.com/ros2/rviz/issues/381>)
    * Pass through CXX flags
    Signed-off-by: Emerson Knapp <mailto:eknapp@amazon.com>
    * fixup
    Signed-off-by: William Woodall <mailto:william@osrfoundation.org>
    * re-add removed libc++ flag, because OSX build always needs it
    Signed-off-by: Emerson Knapp <mailto:eknapp@amazon.com>
  * Propagate toolchain-file to external-project (#374 <https://github.com/ros2/rviz/issues/374>)
    If defined, propagate the CMAKE_TOOLCHAIN_FILE argument to the cmake
    argument of freetype, zlib and ogre projects.
    Change-Id: Ibf2802b96c2238a06191e78a1b2a3128769a83af
    Signed-off-by: Louis Mayencourt <mailto:louis.mayencourt@arm.com>
  * Contributors: Emerson Knapp, lmayencourt

 -- William Woodall <william@osrfoundation.org>  Wed, 08 May 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (5.1.0-1bionic) bionic; urgency=high

  * Skip the system directories when looking for OGRE (#371 <https://github.com/ros2/rviz/issues/371>)
  * Contributors: Scott K Logan

 -- William Woodall <william@osrfoundation.org>  Mon, 14 Jan 2019 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (5.0.0-1bionic) bionic; urgency=high

  * Changed ZLIB_ROOT -> ZLIB_DIR (#349 <https://github.com/ros2/rviz/issues/349>)
  * Contributors: Mikael Arguedas

 -- William Woodall <william@osrfoundation.org>  Tue, 04 Dec 2018 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (4.0.1-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 28 Jun 2018 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (4.0.0-1bionic) bionic; urgency=high

  * Changed the download timeout for Ogre to be twenty (20) minutes. (#323 <https://github.com/ros2/rviz/issues/323>)
  * Contributors: Dirk Thomas, Martin Idel, Mikael Arguedas, Russ

 -- William Woodall <william@osrfoundation.org>  Wed, 27 Jun 2018 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (3.0.0-1bionic) bionic; urgency=high

  * Updated Ogre to 1.10.11. (#181 <https://github.com/ros2/rviz/issues/181>)

 -- William Woodall <william@osrfoundation.org>  Wed, 07 Feb 2018 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (2.0.0-1bionic) bionic; urgency=high

  * First version for ROS 2.
  * Contributors: Andreas Greimel, Andreas Holzner, Chris Ye, Johannes Jeising, Martin Idel, Steven! Ragnarok, William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Dec 2017 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (1.12.11-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 02 Aug 2017 00:00:00 -0000

ros-eloquent-rviz-ogre-vendor (1.12.10-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 05 Jun 2017 17:37:00 -0000

ros-eloquent-rviz-ogre-vendor (1.12.9-1bionic) bionic; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 05 Jun 2017 14:23:00 -0000

ros-eloquent-rviz-ogre-vendor (1.12.8-1bionic) bionic; urgency=high





=== debian/control ===
Source: ros-eloquent-rviz-ogre-vendor
Section: misc
Priority: optional
Maintainer: Jacob Perron <jacob@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), git, libfreetype6-dev, libgl1-mesa-dev, libglu1-mesa-dev, libx11-dev, libxaw7-dev, libxrandr-dev, pkg-config, ros-eloquent-ament-cmake, ros-eloquent-ros-workspace
Homepage: https://www.ogre3d.org/
Standards-Version: 3.9.2

Package: ros-eloquent-rviz-ogre-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfreetype6, libfreetype6-dev, libgl1-mesa-dev, libglu1-mesa-dev, libx11-dev, libxaw7-dev, libxrandr-dev, ros-eloquent-ros-workspace
Description: Wrapper around ogre3d, it provides a fixed CMake module and an ExternalProject build of ogre.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-rviz-ogre-vendor//opt/ros/eloquent/lib/:$(CURDIR)/debian/ros-eloquent-rviz-ogre-vendor//opt/ros/eloquent/opt/rviz_ogre_vendor/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
